<?php

namespace xenarabia\postPanel\Cron;

class postsPanelCache
{

    public static function updateUserPostsCounts()
    {
        $db = \XF::db();

        // Delete old data from cache table to update it whit the new data
        $db->query("DELETE FROM xa_posts_panel");

        // Get users counts
        $usersCounts = $db->fetchOne('SELECT COUNT(*) FROM xf_user');


        $repo =  \XF::app()->em()->getRepository('xenarabia\postPanel\XF:PostsPanelRepo');

        // Add data to cache tabel 
        for ($user_id = 1; $user_id <= $usersCounts; $user_id++) {
            $allStats = $repo->grbPostAndThreadCountsForCache($user_id);

            foreach ($allStats as $subForumStats) {
                $nodeId = $subForumStats['node_id'];
                $postCount = $subForumStats['post_count'];
                $threadCount = $subForumStats['thread_count'];

                $db->query("INSERT INTO xa_posts_panel VALUES ($user_id, $nodeId, $postCount, $threadCount)");
            }
        }
    }


    protected function getPostsPanelRepsitery()
    {
        $app = \XF::app();
        return $app->em()->getRepository('xenarabia\postPanel\XF:PostsPanelRepo');
    }
}
